unit crtgraph;
interface
 uses crt,graph;
 const
   AltX=45;
   Esc=27;
   back=8;
   noncolor=$FF;
   upkey=72;
   dounkey=80;
   leftkey=75;
   rightkey=77;
   rightup=73;
   leftup=71;
   leftdoun=79;
   rightdoun=81;
   Enter=13;
   up=0;
   doun=1;
   F1=59;
   F2=60;
   F3=61;
   F4=62;
   F5=63;
   F6=64;
   F7=65;
   F8=66;
   F9=67;
   F10=68;
   key0=48;
   key1=49;
   key2=50;
   key3=51;
   key4=52;
   key5=53;
   key6=54;
   key7=55;
   key8=56;
   key9=57;

 function readstringgraph(x,y:integer):string    ;
  function readrealgraph(x,y:integer):real      ;
  function readintgraph(x,y:integer):integer      ;

implementation
  function readrealgraph(x,y:integer):real;
   var acoeff:real;
       f:integer;
       s:string;
   begin
    s:=readstringgraph(x,y);
    val(s,acoeff,f);
    readrealgraph:=acoeff;
   end;
  function readintgraph(x,y:integer):integer;
   var acoeff,f:integer;
       s:string;
   begin
    s:=readstringgraph(x,y);
    val(s,acoeff,f);
    readintgraph:=acoeff;
   end;
  function readstringgraph;
   var flg,acoeff:integer;
       coeff:char;
       texts,s:string;
       lentext:byte absolute texts;
   begin
    texts:='';
    repeat
     coeff:=readkey;
     acoeff:=ord(coeff);
     case acoeff of
                  back:begin
                        if lentext > 0 then lentext:=lentext-1;
                        setcolor(7);
                        setfillstyle(emptyfill,7);
                        bar(x-1,y,x+lentext*8,y+8);
                        setfillstyle(solidfill,7);
                        floodfill(x,y+1,7);
                        setcolor(1);
                        flg:=1;
                       end;
                  enter:break;
     end;
     if flg<>1 then texts:=texts+coeff;
     outtextxy(x,y,texts);
     flg:=2;
    until acoeff=Enter;
    readstringgraph:=texts;
    end;
begin
writeln('Text-Graph_Compatible_Support_Ver1.0_Init_Ok');
end.