Unit MyKurs;

Interface

Uses KursObjs, Buttons;

Const
     StopESC    = 27;

Type
    PSimpleSourcer=^TSimpleSourcer; { ⥩訩 筨  }
    TSimpleSourcer=Object(TSourcer)
           L:Real; { ⥭ᨢ ⮪ }
           Constructor Init(AName:Word; AL:Real);
                       { ᢠ AL  L  뢠  ।}
           Procedure NextEventTime; Virtual;
                     { ᢠ  NextEvent -ln(R)/L }
    End;

    PEqualSourcer=^TEqualSourcer; {  筨  }
    TEqualSourcer=Object(TSourcer)
           T1, T2:Real; { Min  Max ६ }
           Constructor Init(AName:Word; AT1, AT2:Real);
           Procedure NextEventTime; Virtual;
                     { ᢠ  NextEvent R*T1+(1-R)*T2 }
    End;

    PMyBuffer=^TMyBuffer; {  ⥬ }
    TMyBuffer=Object(TBuffer)
           Procedure AddToBuffer(Var Rq:TRequest); Virtual;
                     { 頥   ,   ⮣ }
                     { 頥   ⪠ }
           Procedure RemoveFromBuffer(Var Rq:TRequest); Virtual;
                     { 頥 ।    }
    End;

    PErl2_Apparat=^TErl2_Apparat; { ਡ,  ૠ 2- 浪 }
    TErl2_Apparat=Object(TApparat)
           L:Real;
           Constructor Init(AL:Real);
           Procedure NextEventTime; Virtual;
    End;

    PWordArray=^TWordArray;
    TWordArray=Array[0..65520 Div SizeOf(Word)]Of Word;

    PMyAdministrator=^TMyAdministrator; { ,  ࠪ,  }
    TMyAdministrator=Object(TAdministrator)
           Gend,    {஢, ࠡ⠭, ⪠}
           Hndl,
           Failed:Array[1..2]Of Longint; {  i- 筨}
           TL1, SqTL1:Real; {㬬 ६ ॡ뢠   1- 筨}
                            {  㬬 ⮢ ६ ...}
           Step:Word;
           Top2:Array[1..2]Of Integer;    { 䨪, 뢮  ࠭ }
           Potk:Array[1..2]Of PWordArray; { ... }
           Dev:Boolean;
           Status:Word;

           Constructor Init(AStep:Word);
           Destructor Done; Virtual;
           Procedure InitAdministrator; Virtual;
                     { ந 室 ᯨ᮪ ன }
           Procedure ShowAdministrator; Virtual;
                     { ⮡ࠦ 䨪  ଠ  ⥪.ﭨ ⥬ }

           Function CanContinue:Boolean; Virtual;
                    {   ⨥ ESC,   Status }
                    { ᮮ⢥騬 ࠧ }
           Procedure RequestGenerated(Var Rq:TRequest); Virtual;
                     { 稢 稪 ᣥ஢  }
                     {   室 䨪 }
           Procedure RequestFailed(Var Rq:TRequest); Virtual;
                     { 稢 稪 ⪠  }
           Procedure RequestHandled(Var Rq:TRequest); Virtual;
                     { 稢 稪 ࠡ⠭  }
                     {  㬬୮ ६   }
         Private
           P1, P2:PPanel;
    End;

    PCountRqsAdmin=^TCountRqsAdmin; {  ६஢ }
    TCountRqsAdmin=Object(TMyAdministrator)
           ContType:Integer;
           LastRq:Integer;
           Constructor Init(AContType, AStep:Integer;
                            AL1, TMn, TMx, LAp, ATAlph, Delt:Real);
           Function CanContinue:Boolean; Virtual;
                    { 頥 False  ⨦ ᥬ delta }
                    { 室 祭,   ⢥ত  }
                    {  True }
           Procedure RequestGenerated(Var Rq:TRequest); Virtual;
                     {  LastRq }
    End;

    PModelAdmin=^TModelAdmin; {  ஢ }
    TModelAdmin=Object(TMyAdministrator)
           RqC:Longint;
           ItSB, CP:PStatusBar;
           LP:PPanel;
           Constructor Init(ARqC:Longint; AStep:Integer;
                            ST1, ST2min, ST2max, AppT, {ADelta,} iTAlph:Real;
                            AItSB:PStatusBar);
           Destructor Done; Virtual;
           Function CanContinue:Boolean; Virtual;
                    { 頥 False  ⨦ .᫠  }
           Procedure ShowAdministrator; Virtual;
           Procedure RequestGenerated(Var Rq:TRequest); Virtual;
    End;

    PProgressSB=^TProgressSB;
    TProgressSB=Object(TStatusBar)
        Function GetString:String; Virtual;
    End;

    PGlobalSB=^TGlobalSB;
    TGlobalSB=Object(TStatusBar)
        Iter:Integer;
        Max, MaxIter:Integer;
        Constructor Init(AX, AY, AWdth, AHght, ACnvx:Integer; AMaxIter, AMax:Word);
        Procedure SetReq(Req:Integer);
        Function GetString:String; Virtual;
    End;

Implementation

Uses CRT, CMOFunc, Drivers, Graph;

Var L1,  {1st sourcer}
    TMin, TMax, {2nd sourcer}
    LAprt:Real; {Apparat}
    Delta, TAlph:Real; {譮}

{* TSimpleSourcer *}
Constructor TSimpleSourcer.Init(AName:Word; AL:Real);
Begin
  L:=AL;
  Inherited Init(AName);
End;

Procedure TSimpleSourcer.NextEventTime;
Var R:Real;
Begin
  R:=Random;
  NextEvent:=-ln(R)/L;
End;

{* TEqualSourcer= *}
Constructor TEqualSourcer.Init(AName:Word; AT1, AT2:Real);
Begin
  T1:=AT1; T2:=AT2;
  Inherited Init(ANAme);
End;

Procedure TEqualSourcer.NextEventTime;
Var R:Real;
Begin
  R:=Random;
  NextEvent:=R*T1+(1-R)*T2;
End;

{* TMyBuffer *}
Procedure TMyBuffer.AddToBuffer(Var Rq:TRequest);
Type BufferList=Array[0..65520 Div SizeOf(TRequest)]Of TRequest;
Var T:TRequest;
    I, J:Longint;
Begin
  If FreeSize>0    { :-) }
     Then Begin
            BufferList(Buffer^)[Size-FreeSize]:=Rq;
            FillChar(Rq, SizeOf(Rq), 0);
          End
{:( } Else Begin
            I:=Size-1;
            While (I>=0)And(BufferList(Buffer^)[I].Sourcer<>2) Do Dec(I);
            If I<0 Then Exit;
            T:=BufferList(Buffer^)[I]; { -=:-[  ] }
            For J:=I To Size-2 Do
                BufferList(Buffer^)[J]:=BufferList(Buffer^)[J+1];
            BufferList(Buffer^)[Size-1]:=Rq;
            Rq:=T;
          End
End;

Procedure TMyBuffer.RemoveFromBuffer(Var Rq:TRequest);
Type BufferList=Array[0..65520 Div SizeOf(TRequest)]Of TRequest;
Var I:Integer;
Begin
  Rq:=BufferList(Buffer^)[0];
  For I:=0 To Size-FreeSize-2 Do
      BufferList(Buffer^)[I]:=BufferList(Buffer^)[I+1];
  FillChar(BufferList(Buffer^)[Size-FreeSize-1], SizeOf(TRequest), 0);
End;

{* TErl2_Apparat *}
Constructor TErl2_Apparat.Init(AL:Real);
Begin
  L:=AL;
  Inherited Init;
End;

Procedure TErl2_Apparat.NextEventTime;
Var R, T:Real;
    I:Byte;
Begin
  T:=0;
  For I:=1 To 2 Do
      Begin
        R:=Random;
        T:=T+(-ln(R)/L);
      End;
  NextEvent:=T;
End;

{* TMyAdministrator *}
Constructor TMyAdministrator.Init(AStep:Word);
Var I:Byte;
Begin
  Inherited Init;
  Step:=AStep;
  Dev:=False;
  For I:=1 To 2 Do
      GetMem(Potk[I], 500*SizeOf(Word));
  Top2[1]:=1; Top2[2]:=1;
  P1:=New(PPanel, Init(80, 420, 440, 40, 2));
  P2:=New(PPanel, Init(520, 420, 120, 40, 2));
  Status:=0;
End;

Destructor TMyAdministrator.Done;
Var I:Byte;
Begin
  For I:=1 To 2 Do
      FreeMem(Potk[I], 500*SizeOf(Word));
  Dispose(P1, Done); Dispose(P2, Done);
  Inherited Done;
End;

Procedure TMyAdministrator.InitAdministrator;
Begin
  AddDevice(New(PSimpleSourcer, Init(1, L1)));
  AddDevice(New(PEqualSourcer, Init(2, TMin, TMax)));
  AddDevice(New(PMyBuffer, Init(5)));
  AddDevice(New(PErl2_Apparat, Init(LAprt)));
  TL1:=0; SqTL1:=0;
  Gend[1]:=0; Failed[1]:=0; Hndl[1]:=0;
  Gend[2]:=0; Failed[2]:=0; Hndl[2]:=0;
End;

Procedure TMyAdministrator.ShowAdministrator;

  Procedure DrawMain;
  Var S:String[5];
      I, J:Integer;
  Begin
    ClearDevice;
    Dev:=True;
    SetColor(15);
    DrawCoord(65, 180, 510, 150, 't', 'P1');
    DrawCoord(65, 370, 510, 150, 't', 'P2');
    SetTextStyle(DefaultFont, VertDir, 1);
    For I:=1 To 25 Do
        Begin
          Str(Step*I, S);
          For J:=1 To 2 Do
            Begin
              MoveTo(65+20*I, 180+190*(J-1));
              LineRel(0, 4);
              OutTextXY(65+20*I+TextHeight(S) Shr 1, 180+190*(J-1)+4, S);
            End;
        End;
    SetTextStyle(DefaultFont, HorizDir, 1);
    P2^.Show;
    SetColor(15); OutTextXY(545, 440, 'ESC-');
    SetColor(9); OutTextXY(580, 440, 'stop');
    J:=0;
    While (J<Top2[1])Or(J<Top2[2]) Do
          Begin
            If J<Top2[1] Then PutPixel(66+J, 180-Potk[1]^[J], 10);
            If J<Top2[2] Then PutPixel(66+J, 370-Potk[2]^[J], 11);
            Inc(J);
          End;
  End;

Const
     Hdr:String='Dev  Gend  Hndl  Fail';

Var X, Y:Word;
    D:Array[1..4]Of Longint;
    S:String;
    I, J:Byte;

Begin
  If Not Dev Then DrawMain;
  X:=80+(440-TextWidth(Hdr)) Shr 1;
  P1^.Show;
  SetColor(14);
  OutTextXY(X, 425, Hdr);
  SetColor(10);
  For J:=1 To 2 Do
      Begin
        D[1]:=J; D[2]:=Gend[J]; D[3]:=Hndl[J]; D[4]:=Failed[J];
        FormatStr(S, '%2d  %5d %5d %5d', D);
        SetColor(9+J);
        OutTextXY(X, 425+J*10, S);
      End;
End;

Function TMyAdministrator.CanContinue:Boolean;
Var C:Char;
Begin
  If KeyPressed Then C:=ReadKey Else C:=#0;
  If C=#27 Then
     If AskUser('ࢠ ஢ ?')=Yes
        Then Status:=StopESC Else C:=#0;
  CanContinue:=(C<>#27);
End;

Procedure TMyAdministrator.RequestGenerated(Var Rq:TRequest);

  Procedure PackWArray(Var W:TWordArray; Var Top:Integer);
  Var I:Integer;
  Begin
    For I:=1 To (Top Shr 1) Do
        W[I]:=W[2*I];
    Top:=Top Shr 1;
  End;

Var L:Real;

Begin
  Inc(Gend[Rq.Sourcer]);
  If Gend[Rq.Sourcer]>=Top2[Rq.Sourcer]*Step Div 20 Then
     Begin
       L:=140*Failed[Rq.Sourcer]/Gend[Rq.Sourcer];
       Potk[Rq.Sourcer]^[Top2[Rq.Sourcer]]:=Round(L);
       PutPixel(66+Top2[Rq.Sourcer],
                180+190*(Rq.Sourcer-1)-Potk[Rq.Sourcer]^[Top2[Rq.Sourcer]],
                9+Rq.Sourcer);
       Inc(Top2[Rq.Sourcer]);
       If Top2[Rq.Sourcer]=500 Then
          Begin
            PackWArray(Potk[1]^, Top2[1]);
            PackWArray(Potk[2]^, Top2[2]);
            Step:=Step Shl 1;
            Dev:=False;
          End;
     End;
End;

Procedure TMyAdministrator.RequestFailed(Var Rq:TRequest);
Begin
  Inc(Failed[Rq.Sourcer]);
End;

Procedure TMyAdministrator.RequestHandled(Var Rq:TRequest);
Begin
  Inc(Hndl[Rq.Sourcer]);
  If Rq.Sourcer=1 Then
     Begin
       TL1:=TL1+Rq.TimeLive;
       SqTL1:=SqTL1+SQR(Rq.TimeLive);
     End;
End;

{* TCountRqsAdmin *}
Constructor TCountRqsAdmin.Init(AContType, AStep:Integer;
                     AL1, TMn, TMx, LAp, ATAlph, Delt:Real);
Begin
  ContType:=AContType;
  L1:=AL1;
  TMin:=TMn; TMax:=TMx;
  LAprt:=LAp;
  Delta:=Delt; TAlph:=ATAlph;
  LastRq:=0;
  Inherited Init(AStep);
End;

Function TCountRqsAdmin.CanContinue:Boolean;
  Function W2S(W:Longint):String;
  Var S:String[20];
  Begin
    Str(W, S);
    W2S:=S;
  End;

Var B:Boolean;
    S:String[20];
    D:Real;
    P:PPanel;
    MB:PPanel; OB:PButton;
    C:Char; S1,S2:String[80];
Begin
  Case ContType Of
{:-(}  0:If (Hndl[1]>0)And(Hndl[2]>0)And(Failed[1]>0)And(Failed[2]>0) Then
            B:=((TAlph*SQRT( (1 - Failed[1]/Gend[1]) / Failed[1]))<Delta) And
            ((TAlph*SQRT( (1 - Failed[2]/Gend[2]) / Failed[2]))<Delta) And
            ((TAlph/(TL1/(Hndl[1]))*
                   SQRT( (SqTL1/Hndl[1] - SQR(TL1/Hndl[1]) ) / Hndl[1]))<Delta)
            Else B:=False;
{:-P}  1:If LastRq<Step
            Then B:=True
            Else Begin
                   New(P, Init(100, 100, 200, 74, 2));
                   P^.Show;
                   SetColor(15);
                   OutTextXY(150, 110, '譮');
                   SetColor(9);
                   If (Gend[1]=0)Or(Failed[1]=0)
                      Then S:='।.'
                      Else Begin
                             D:=(TAlph*SQRT( (1 - Failed[1]/Gend[1]) / Failed[1]));
                             Str(D:1:4, S); S:='-  ࢮ : '+S;
                           End;
                   OutTextXY(120, 130, S);
                   If (Gend[2]=0)Or(Failed[2]=0)
                      Then S:='।.'
                      Else Begin
                             D:=(TAlph*SQRT( (1 - Failed[2]/Gend[2]) / Failed[2]));
                             Str(D:1:4, S); S:='-  ஬ : '+S;
                           End;
                   OutTextXY(120, 140, S);
                   If Hndl[1]=0
                      Then S:='।'
                      Else Begin
                             D:=(TAlph/(TL1/(Hndl[1]))*
                                 SQRT( (SqTL1/Hndl[1] - SQR(TL1/Hndl[1]) ) / Hndl[1]));
                             Str(D:1:4, S); S:='-  . : '+S;
                           End;
                   OutTextXY(120, 150, S);
                   B:=(AskUser('த\n६஢ ?')=Yes);
                   Dispose(P, Done);
                   Dev:=False;
                   LastRq:=0;
                 End;
  End;
  B:=Not B;
  If Not B And (ContType=0) Then
     Begin
       MB:=New(PPanel, Init(160, 198, 320, 84, 2));
       OB:=New(PTextButton, Init(295, 243, 50, 20, 2, 'Ok'));
       MB^.Show;
       SetColor(9);
       S1:=' 㤮⢮७ ࠬ஢';
       S2:='室 '+W2S(Gend[1])+' .';
       OutTextXY(170+(300-TextWidth(S1)) Shr 1, 215, S1);
       OutTextXY(170+(300-TextWidth(S2)) Shr 1, 225, S2);
       OB^.Show;
       Repeat
         C:=Upcase(ReadKey);
         If C=#13 Then
            Begin
              OB^.Press(True); OB^.Show;
              Delay(250);
              OB^.Press(False); OB^.Show;
              Delay(10);
            End;
       Until C=#13;
       Dispose(MB, Done);
       Dispose(OB, Done);
     End;
  CanContinue:=B And Inherited CanContinue;
End;

Procedure TCountRqsAdmin.RequestGenerated(Var Rq:TRequest);
Begin
  Inherited RequestGenerated(Rq);
  Inc(LastRq);
End;

Constructor TModelAdmin.Init(ARqC:Longint; AStep:Integer;
                             ST1, ST2min, ST2max, AppT, {ADelta,} iTAlph:Real;
                             AItSB:PStatusBar);
Begin
  L1:=ST1;
  TMin:=ST2min;
  TMax:=ST2max;
  LAprt:=AppT;
  Inherited Init(AStep);
  RqC:=ARqC;
  TAlph:=iTAlph;
  CP:=New(PProgressSB, Init(0, 460, 319, 19, 2));
  New(LP, Init(0, 420, 119, 40, 2));
  ItSB:=AItSB;
End;

Destructor TModelAdmin.Done;
Begin
  Dispose(CP ,Done);
  Inherited Done;
End;

Function TModelAdmin.CanContinue:Boolean;
Var C:Char;
Begin
  CanContinue:=((Gend[1]<RqC)And(Gend[2]<RqC))And(Inherited CanContinue);
End;

Procedure TModelAdmin.ShowAdministrator;
Const S:String='஢ ⥬ ᮢ 㦨';

Var BDev:Boolean;
    SN:String[20];
    B:Word;
Begin
  BDev:=Dev;
  Inherited ShowAdministrator;
  If Not BDev Then
     Begin
       SetFillStyle(SolidFill, 15);
       Bar(0, 0, 640, 20);
       SetColor(9);
       OutTextXY((GetMaxX-TextWidth(S)) Shr 1, (20-TextHeight(S)) Shr 1, S);
       CP^.Show; ItSB^.Show;
       LP^.Show;
       Str(L1:1:2, SN);
       SN:='lam1='+SN;
       SetColor(12);
       B:=TextWidth(SN);
       OutTextXY((120-B) Shr 1, 439, SN);
     End;
{  ReadKey;}
End;

Procedure TModelAdmin.RequestGenerated(Var Rq:TRequest);
Var A:Integer;
    L, L2:Real;
Begin
  Inherited RequestGenerated(Rq);
  A:=Gend[2];
  If Gend[1]>A Then A:=Gend[1];
  L2:=A/RqC;
  L:=100*L2;
  CP^.SetPercent(Trunc(L));
  PGlobalSB(ItSB)^.SetReq(A);
End;

Function TProgressSB.GetString:String;
Var S:String[5];
Begin
  Str(Prcnt, S);
  GetString:='ண : '+S+'%';
End;

Constructor TGlobalSB.Init(AX, AY, AWdth, AHght, ACnvx:Integer; AMaxIter, AMax:Word);
Begin
  Inherited Init(AX, AY, AWdth, AHght, ACnvx);
  Iter:=1;
  MaxIter:=AMaxIter;
  Max:=AMax;
End;

Procedure TGlobalSB.SetReq(Req:Integer);
Var A, B, L:Real;
Begin
  A:=(Iter-1)*Max+Req; B:=Max*MaxIter;
  L:=100*A/B;
  SetPercent(Round(L));
End;

Function TGlobalSB.GetString:String;
Var S1, S2:String[5];
Begin
  Str(Iter, S1); Str(MaxIter, S2);
  GetString:=' : '+S1+'  '+S2;
End;

END.