UNIT Outcomes;
Interface
Uses Graph,Crt,mainmenu;
Type
  sav=record
       Pn:array[1..20,1..3] of real;
       Mn:array[1..20,1..3] of real;
       Ln:array[1..20] of real;
       P:array[1..20,1..3] of integer;
       M:array[1..20,1..3] of integer;
       L:array[1..20] of integer;
       max:real;
       mashtabx,mashtabM,mashtabP:integer;
       cont:integer;
     end;

 Resultat=object
  cont:integer;
  mashtabx,mashtabM,mashtabP:integer;
  Pn:array[1..20,1..3] of real;
  Mn:array[1..20,1..3] of real;
  Ln:array[1..20] of real;
  POut:array[1..20,1..3] of integer;
  MOut:array[1..20,1..3] of integer;
  LOut:array[1..20] of integer;
  max:real;
  Procedure Init;
  Procedure Mashtabing(m:main_menu);
  Procedure PutPoint(tx,ty,PutColor:integer);
  Procedure ResultGraphic(Ngraph:integer);
  Procedure ResultCrt;
  procedure Save;
  procedure Load;
 end;
const x0=55;yp=20;xp=560;yf=60;ym=150;y0=460;

{===========================================================================}

Implementation

procedure Resultat.Save;
var
f:file of sav;
i,j:integer;
h:sav;
begin
  assign(f,'laststat.rez');
  rewrite(f);
  for i:=1 to 20 do
   for j:=1 to 3 do
    begin
      h.pn[i,j]:=Pn[i,j];
      h.mn[i,j]:=Mn[i,j];
      h.ln[i]:=Ln[i];
      h.p[i,j]:=POut[i,j];
      h.m[i,j]:=MOut[i,j];
      h.l[i]:=LOut[i];
    end;
  h.mashtabx:=mashtabx;
  h.mashtabP:=mashtabP;
  h.mashtabM:=mashtabM;
  h.max:=max;
  h.cont:=cont;
  write(f,h);
  close(f);
end;


procedure Resultat.Load;
var
f:file of sav;
i,j:integer;
h:sav;
begin
  assign(f,'laststat.rez');
  reset(f);
  read(f,h);
  for i:=1 to 20 do
   for j:=1 to 3 do
    begin
      Pn[i,j]:=h.pn[i,j];
      Mn[i,j]:=h.mn[i,j];
      Ln[i]:=h.ln[i];
      POut[i,j]:=h.p[i,j];
      MOut[i,j]:=h.m[i,j];
      LOut[i]:=h.l[i];
    end;
  mashtabx:=h.mashtabx;
  mashtabP:=h.mashtabP;
  mashtabM:=h.mashtabM;
  max:=h.max;
  cont:=h.cont;
end;



Procedure Resultat.Mashtabing(m:main_menu);
var
 i,nmax:integer;
begin
 mashtabx:=round((xp-x0)/(m.tau2-m.tau1)*m.dtau);
 nmax:=1;
 max:=Mn[1,1];
 for i:=2 to cont do
   if Mn[i,1]>max then
     begin
       max:=Mn[i,1];
       nmax:=i;
     end;
  mashtabM:=round((y0-ym)/max);
  mashtabP:=y0-yf;
   for i:=1 to cont do
    begin
      LOut[i]:=x0+round(mashtabx*(i-1));
      POut[i,1]:=y0-round(mashtabP*Pn[i,1]);
      MOut[i,1]:=y0-round(mashtabM*Mn[i,1]);
      POut[i,2]:=y0-round(mashtabP*Pn[i,2]);
      MOut[i,2]:=y0-round(mashtabM*Mn[i,2]);
      POut[i,3]:=y0-round(mashtabP*Pn[i,3]);
      MOut[i,3]:=y0-round(mashtabM*Mn[i,3]);
    end;
end;



Procedure Resultat.Init;
var
 i:integer;
begin
 cont:=1;
for i:=1 to 20 do
begin
 POut[i][1]:=0;
 POut[i][2]:=0;
 POut[i][3]:=0;
 MOut[i][1]:=0;
 MOut[i][2]:=0;
 MOut[i][3]:=0;
 LOut[i]:=0;
end;
end;

Procedure Resultat.PutPoint(tx,ty,PutColor:integer);
begin
   setcolor(Putcolor);
   setlinestyle(0,0,3);
   circle(tx,ty,2);
   setlinestyle(0,0,1);
end;

Procedure Resultat.ResultGraphic(Ngraph:integer);
var
 i,pric:integer;
 ne:char;
 xnum:string[6];
begin
ClearDevice;
SetColor(white);
SetTextStyle(0,0,1);
setlinestyle(0,0,1);
Rectangle(x0-10,yp,620,460);
setlinestyle(0,0,1);

for i:=0 to 4 do
begin
 if (Ngraph<4) then
 case i of
   0: OutTextxy(0,y0-round(i/4*mashtabP)-1,'0');
   1: OutTextxy(0,y0-round(i/4*mashtabP)-1,'1/4');
   2: OutTextxy(0,y0-round(i/4*mashtabP)-1,'1/2');
   3: OutTextxy(0,y0-round(i/4*mashtabP)-1,'3/4');
   4: OutTextxy(0,y0-round(i/4*mashtabP)-1,'1');
  end
   else
    case i of
    0,2,4:begin str((max*i/4):4:2,xnum);
               outtextxy(0,y0-round(i/4*mashtabP)-1,xnum);
          end;
    end;

 Line(x0-10-6,y0-round(i/4*mashtabp),x0-10,y0-round(i/4*mashtabp));
end;

OutTextxy(607,465,'L');
 for i:=1 to cont do
  begin
    Line(LOut[i],454,LOut[i],460);
    str(Ln[i]:4:2,xnum);
    setcolor(15);
    OutTextxy(LOut[i]-10,465,xnum);
  end;

case (NGraph) of
  1:
   begin
    OutTextxy(1,25,'P1');
    OutTextxy(80,3,'ᨬ ⭮ ⪠ P1  ⥭ᨢ ਡ L');
    for i:=1 to cont do
     {PutPoint(50*round(LOut[iP])-320,460-Round(300*POut[iP][1]),11);
    } PutPoint(LOut[i],POut[i,1],11);
   end;
  2:
   begin
    OutTextxy(1,25,'P2');
    OutTextxy(80,3,'ᨬ ⭮ ⪠ P2  ⥭ᨢ ਡ L');
    for i:=1 to cont do
    { PutPoint(50*round(LOut[iP])-320,460-Round(300*POut[iP][2]),12);
    } PutPoint(LOut[i],POut[i,2],12);
   end;
  3:
   begin
    OutTextxy(1,25,'P3');
    OutTextxy(80,3,'ᨬ ⭮ ⪠ P3  ⥭ᨢ ਡ L');
    for i:=1 to cont do
     {PutPoint(50*round(LOut[iP])-320,460-Round(300*POut[iP][3]),13);
     }PutPoint(LOut[i],POut[i,3],13);
   end;
  4:
   begin
    OutTextxy(1,25,'M1');
    OutTextxy(80,3,'ᨬ .  M1  ⥭ᨢ ਡ L');
    for i:=1 to cont do
     PutPoint(LOut[i],MOut[i,1],11);
   end;
  5:
   begin
    OutTextxy(1,25,'M2');
    OutTextxy(80,3,'ᨬ .  M2  ⥭ᨢ ਡ L');
    for i:=1 to cont do
     PutPoint(LOut[i],MOut[i,2],12);
   end;
  6:
   begin
    OutTextxy(1,25,'M3');
    OutTextxy(80,3,'ᨬ .  M3  ⥭ᨢ ਡ L');
    for i:=1 to cont do
     PutPoint(LOut[i],MOut[i,3],13);
   end;
end;{of case}

 ne:=ReadKey;

end;

Procedure Resultat.ResultCrt;
var
  ii:integer;
begin
 for ii:=1 to cont-1 do
 begin
  writeln(ii);
  writeln('P[1]= ',POut[ii,1]);
  writeln('P[2]= ',POut[ii,2]);
  writeln('M[1]= ',MOut[ii,1]);
  writeln('M[2]= ',MOut[ii,2]);
  writeln('LambdaServe= ',LOut[ii]);
  writeln;
 end;
end;
end.



