unit Tmenulib;
interface
uses crt,graph,Ilib_1_1,Tprelib;
type  TRColor=record
                C:TColor;
                TextC:TextPal;
               end;

      TPMenuBKey=^TMenuBKey;
      TMenuBKey=object(TBaseKey)
                 FocusC:word;
                 Focusbol:boolean;
                 P:array[1..4] of pointer;
                 Constructor Init(R:TRRect;C:Tcolor;im:boolean;Bars:byte;Foc:word);
                 Procedure Show; virtual;
                 Procedure Co_Show; virtual;
                 Procedure Hide; virtual;
                 Procedure TakeFocus;
                 Procedure LostFocus;
                private
                 Procedure ShowFocus(colup,coldown:word);
                end;
      TPTextKey=^TTextKey;
      TTextKey=object
                Text:TPBlocedLine;
                Key:TPBaseKey;
                constructor Init(R:TRRect;C:TRColor;im:boolean;bar:byte;Opt:byte;S:string);
                destructor  Done;                  virtual;
                procedure   Show;                  virtual;
                procedure   Hide;                  Virtual;
                procedure   ReDraw                        ;
                procedure   Moving                        ;
                procedure   Move(nx,ny:integer)           ;
                procedure   Moveto(nx,ny:integer)         ;
                procedure   Resizing                     ;
                procedure   Resize(dx,dy:Integer)         ;
                procedure   Resizeto(R:TRRect)          ;
                procedure   SetNewColor(C:TRColor)  ;
                procedure   GetExtent(var R:TRRect);
                procedure   Press_Key;
               end;
      TPMenuKey=^TMenuKey;
      TMenuKey=object
                Text:TPBlocedLine;
                Key:TPMenuBKey;
                constructor Init(R:TRRect;C:TRColor;im:boolean;bar:byte;Opt:byte;S:string);
                destructor  Done;                  virtual;
                procedure   Show;                  virtual;
                procedure   Hide;                  Virtual;
                procedure   ReDraw                        ;
                procedure   Moving                        ;
                procedure   Move(nx,ny:integer)           ;
                procedure   Moveto(nx,ny:integer)         ;
                procedure   Resizing                     ;
                procedure   Resize(dx,dy:Integer)         ;
                procedure   Resizeto(R:TRRect)          ;
                procedure   SetNewColor(C:TRColor)  ;
                procedure   GetExtent(var R:TRRect);
                procedure   Press_Key;
                procedure   TakeFocus;
                procedure   LostFocus;
               end;

implementation
Constructor TMenuBKey.Init(R:TRRect;C:Tcolor;im:boolean;Bars:byte;Foc:word);
begin
FocusC:=foc;
inherited init(r,c,im,bars);
Focusbol:=false;
end;
Procedure TMenuBKey.Show;
begin
inc(loc.a.x);
inc(loc.a.y);
dec(loc.b.x);
dec(loc.b.y);
inherited show;
dec(loc.a.x);
dec(loc.a.y);
inc(loc.b.x);
inc(loc.b.y);
end;
Procedure TMenuBKey.Co_Show;
begin
{inc(loc.a.x);
inc(loc.a.y);
dec(loc.b.x);
dec(loc.b.y);}
inherited Co_Show;
{dec(loc.a.x);
dec(loc.a.y);
inc(loc.b.x);
inc(loc.b.y);}
end;

Procedure TMenuBKey.Hide;
begin
inc(loc.a.x);
inc(loc.a.y);
dec(loc.b.x);
dec(loc.b.y);
inherited hide;
dec(loc.a.x);
dec(loc.a.y);
inc(loc.b.x);
inc(loc.b.y);
end;

procedure TMenuBKey.TakeFocus;
begin
if imag then begin
getmem(p[1],imagesize(loc.a.x,loc.a.y,loc.a.x,loc.b.y));
getimage(loc.a.x,loc.a.y,loc.a.x,loc.b.y,p[1]^);

getmem(p[2],imagesize(loc.b.x,loc.a.y,loc.b.x,loc.b.y));
getimage(loc.b.x,loc.a.y,loc.b.x,loc.b.y,p[2]^);

getmem(p[3],imagesize(loc.a.x,loc.a.y,loc.b.x,loc.a.y));
getimage(loc.a.x,loc.a.y,loc.b.x,loc.a.y,p[3]^);

getmem(p[4],imagesize(loc.a.x,loc.b.y,loc.b.x,loc.b.y));
getimage(loc.a.x,loc.b.y,loc.b.x,loc.b.y,p[4]^);
end;
ShowFocus(FocusC,FocusC);
end;
procedure TMenuBKey.LostFocus;
begin
ShowFocus(Colors.Light,Colors.Dark);
if imag then
 begin
putimage(loc.a.x,loc.a.y,p[1]^,copyput);
freemem(p[1],imagesize(loc.a.x,loc.a.y,loc.a.x,loc.b.y));

putimage(loc.b.x,loc.a.y,P[2]^,copyput);
freemem(p[2],imagesize(loc.b.x,loc.a.y,loc.b.x,loc.b.y));

putimage(loc.a.x,loc.a.y,p[3]^,copyput);
freemem(p[3],imagesize(loc.a.x,loc.a.y,loc.b.x,loc.a.y));

putimage(loc.a.x,loc.b.y,p[4]^,copyput);
freemem(p[4],imagesize(loc.a.x,loc.b.y,loc.b.x,loc.b.y));
end;

end;
procedure TMenuBKey.ShowFocus;
var col:word;
begin
 col:=getcolor;
 Show;
 if ColUp<>ColDown then begin

 setcolor(colup);
 line(Loc.a.x+1,Loc.a.y+1,Loc.b.x-2,Loc.a.y+1);
 line(Loc.a.x+1,Loc.a.y+1,Loc.a.x+1,Loc.b.y-1);
 setcolor(coldown);
 line(Loc.b.x-1,Loc.b.y-1,Loc.a.x+2,Loc.b.y-1);
 line(Loc.b.x-1,Loc.b.y-1,Loc.b.x-1,Loc.a.y+1);
 setcolor(colors.base);
 rectangle(loc.a.x,loc.a.y,loc.b.x,loc.b.y);
end
else begin
 setcolor(colup);
 line(Loc.a.x,Loc.a.y,Loc.b.x-1,Loc.a.y);
 line(Loc.a.x,Loc.a.y,Loc.a.x,Loc.b.y);
 line(Loc.a.x+1,Loc.a.y+1,Loc.b.x-2,Loc.a.y+1);
 line(Loc.a.x+1,Loc.a.y+1,Loc.a.x+1,Loc.b.y-1);
 setcolor(coldown);
 line(Loc.b.x,Loc.b.y,Loc.a.x+1,Loc.b.y);
 line(Loc.b.x,Loc.b.y,Loc.b.x,Loc.a.y);
 line(Loc.b.x-1,Loc.b.y-1,Loc.a.x+2,Loc.b.y-1);
 line(Loc.b.x-1,Loc.b.y-1,Loc.b.x-1,Loc.a.y+1);
end;
 setcolor(col);
end;

constructor TTextKey.Init;
begin
 dec(r.b.x,bar);
 dec(r.b.y,bar);
 inc(r.a.x,bar);
 inc(r.a.y,bar);
 Text:=new(TPBlocedLine,init(R,C.textC,Opt,S));
 dec(r.a.x,bar);
 dec(r.a.y,bar);
 inc(r.b.x,bar);
 inc(r.b.y,bar);
 Key:=new(TPBaseKey,init(R,C.C,im,bar));
end;
destructor  TTextKey.Done;
begin
 dispose(text,done);
 dispose(key,done);
end;
procedure   TTextKey.Show;
begin
Key^.show;
Text^.show;
end;
procedure   TTextKey.Hide;
begin;
Key^.hide;
end;
procedure   TTextKey.ReDraw;
begin
Key^.ReDraw;
Text^.ReDraw;
end;
procedure   TTextKey.Moving;
var r:TRRect;
begin
Text^.hide;
Key^.moving;
Key^.getextent(r);
 dec(r.b.x,Key^.bar);
 dec(r.b.y,Key^.bar);
 inc(r.a.x,Key^.bar);
 inc(r.a.y,Key^.bar);
Text^.Loc:=R;
Text^.show;
end;

procedure   TTextKey.Move(nx,ny:integer);
var R:TRRect;
begin
{Text^.hide;  }
Key^.move(nx,ny);
Key^.getextent(r);
 dec(r.b.x,Key^.bar);
 dec(r.b.y,Key^.bar);
 inc(r.a.x,Key^.bar);
 inc(r.a.y,Key^.bar);
Text^.Loc:=R;
Text^.show;
end;
procedure   TTextKey.Moveto(nx,ny:integer)         ;
var R:TRRect;
begin
{Text^.hide;}
Key^.moveto(nx,ny);
Key^.getextent(r);
 dec(r.b.x,Key^.bar);
 dec(r.b.y,Key^.bar);
 inc(r.a.x,Key^.bar);
 inc(r.a.y,Key^.bar);
Text^.Loc:=R;
Text^.show;
end;
procedure   TTextKey.Resizing;
var R:TRRect;
begin
Text^.hide;
Key^.resizing;
Key^.getextent(r);
 dec(r.b.x,Key^.bar);
 dec(r.b.y,Key^.bar);
 inc(r.a.x,Key^.bar);
 inc(r.a.y,Key^.bar);
Text^.Loc:=R;
Text^.show;
end;
procedure   TTextKey.Resize(dx,dy:Integer);
var R:TRRect;
begin
{Text^.hide;}
Key^.resize(dx,dy);
Key^.getextent(r);
 dec(r.b.x,Key^.bar);
 dec(r.b.y,Key^.bar);
 inc(r.a.x,Key^.bar);
 inc(r.a.y,Key^.bar);
Text^.Loc:=R;
Text^.show;
end;
procedure   TTextKey.Resizeto(R:TRRect);
begin
{Text^.hide;}
Key^.resizeto(R);
Key^.getextent(r);
 dec(r.b.x,Key^.bar);
 dec(r.b.y,Key^.bar);
 inc(r.a.x,Key^.bar);
 inc(r.a.y,Key^.bar);
Text^.Loc:=R;
Text^.show;
end;
procedure   TTextKey.SetNewColor;
begin
hide;
Key^.colors:=C.C;
Text^.setNewColor(C.TextC);
show;
end;
procedure   TTextKey.GetExtent(var R:TRRect);
begin
Key^.Getextent(r);
end;
procedure   TTextKey.Press_Key;
begin
with key^ do
begin
ProGib:=not ProGib;
ReDraw;
end;
Text^.redraw;
delay(150);
with key^ do
begin
ProGib:=not ProGib;
ReDraw;
end;
end;
{***}
constructor TMenuKey.Init;
begin
 dec(r.b.x,bar+1);
 dec(r.b.y,bar+1);
 inc(r.a.x,bar+1);
 inc(r.a.y,bar+1);
 Text:=new(TPBlocedLine,init(R,C.textC,Opt,S));
 dec(r.a.x,bar+1);
 dec(r.a.y,bar+1);
 inc(r.b.x,bar+1);
 inc(r.b.y,bar+1);
 Key:=new(TPMenuBKey,init(R,C.C,im,bar,red));
end;
destructor  TMenuKey.Done;
begin
 dispose(text,done);
 dispose(key,done);
end;
procedure   TMenuKey.Show;
begin
Key^.show;
Text^.show;
end;
procedure   TMenuKey.Hide;
begin;
Key^.hide;
end;
procedure   TMenuKey.ReDraw;
begin
Key^.ReDraw;
Text^.ReDraw;
end;
procedure   TMenuKey.Moving;
var r:TRRect;
begin
Text^.hide;
Key^.moving;
Key^.getextent(r);
 dec(r.b.x,Key^.bar+1);
 dec(r.b.y,Key^.bar+1);
 inc(r.a.x,Key^.bar+1);
 inc(r.a.y,Key^.bar+1);
Text^.Loc:=R;
Text^.show;
end;

procedure   TMenuKey.Move(nx,ny:integer);
var R:TRRect;
begin
{Text^.hide;  }
Key^.move(nx,ny);
Key^.getextent(r);
 dec(r.b.x,Key^.bar+1);
 dec(r.b.y,Key^.bar+1);
 inc(r.a.x,Key^.bar+1);
 inc(r.a.y,Key^.bar+1);
Text^.Loc:=R;
Text^.show;
end;
procedure   TMenuKey.Moveto(nx,ny:integer)         ;
var R:TRRect;
begin
{Text^.hide;}
Key^.moveto(nx,ny);
Key^.getextent(r);
 dec(r.b.x,Key^.bar+1);
 dec(r.b.y,Key^.bar+1);
 inc(r.a.x,Key^.bar+1);
 inc(r.a.y,Key^.bar+1);
Text^.Loc:=R;
Text^.show;
end;
procedure   TMenuKey.Resizing;
var R:TRRect;
begin
Text^.hide;
Key^.resizing;
Key^.getextent(r);
 dec(r.b.x,Key^.bar+1);
 dec(r.b.y,Key^.bar+1);
 inc(r.a.x,Key^.bar+1);
 inc(r.a.y,Key^.bar+1);
Text^.Loc:=R;
Text^.show;
end;
procedure   TMenuKey.Resize(dx,dy:Integer);
var R:TRRect;
begin
{Text^.hide;}
Key^.resize(dx,dy);
Key^.getextent(r);
 dec(r.b.x,Key^.bar+1);
 dec(r.b.y,Key^.bar+1);
 inc(r.a.x,Key^.bar+1);
 inc(r.a.y,Key^.bar+1);
Text^.Loc:=R;
Text^.show;
end;
procedure   TMenuKey.Resizeto(R:TRRect);
begin
{Text^.hide;}
Key^.resizeto(R);
Key^.getextent(r);
 dec(r.b.x,Key^.bar+1);
 dec(r.b.y,Key^.bar+1);
 inc(r.a.x,Key^.bar+1);
 inc(r.a.y,Key^.bar+1);
Text^.Loc:=R;
Text^.show;
end;
procedure   TMenuKey.SetNewColor;
begin
hide;
Key^.colors:=C.C;
Text^.setNewColor(C.TextC);
show;
end;
procedure   TMenuKey.GetExtent(var R:TRRect);
begin
Key^.Getextent(r);
end;
procedure   TMenuKey.Press_Key;
begin
with key^ do
begin
ProGib:=not ProGib;
ReDraw;
end;
Text^.redraw;
delay(150);
with key^ do
begin
ProGib:=not ProGib;
ReDraw;
end;
end;
procedure TMenuKey.TakeFocus;
begin
Key^.TakeFocus;
end;
procedure TMenuKey.LostFocus;
begin
Key^.LostFocus;
end;
begin
{var a,b,c,d:TMenuBKey;

    R:TRRect;
begin
r.a.x:=10;
r.a.y:=10;
r.b.x:=100;
r.b.y:=100;
a.init(r,cDark,True,2,red);
r.a.x:=101;
r.a.y:=101;
r.b.x:=201;
r.b.y:=201;
B.init(r,cDark,True,2,red);
r.a.x:=202;
r.a.y:=202;
r.b.x:=302;
r.b.y:=302;
C.init(r,cDark,True,2,red);
r.a.x:=303;
r.a.y:=303;
r.b.x:=403;
r.b.y:=403;
D.init(r,cDark,True,2,red);

setbkcolor(14);
a.show;
b.show;
c.show;
d.show;

readkey;
for r.a.x:= 1 to 20 do begin
 A.TakeFocus;
 delay(100);
 A.LostFocus;
 B.TakeFocus;
 delay(100);
 B.LostFocus;
 C.TakeFocus;
 delay(100);
 C.LostFocus;
 D.TakeFocus;
 delay(100);
 D.LostFocus;
end;
a.done;
b.done;}
Writeln('Menu_Items_Support_Init_Ok');
end.