Unit CMOFunc;

Interface

Const
     Yes        = 1;
     No         = 2;

Procedure DrawCoord(X0, Y0, Wdth, Hght:Word; Const XLbl, YLbl:String);
Function AskUser(Const Msg:String):Word;

Implementation

Uses Graph, Buttons, Crt;

Procedure DrawCoord(X0, Y0, Wdth, Hght:Word; Const XLbl, YLbl:String);
Begin
  MoveTo(X0, Y0); LineRel(Wdth, 0);
  LineRel(-7, -3); MoveRel(7, 3);
  LineRel(-7, 3);
  MoveTo(X0, Y0); LineRel(0, -Hght);
  LineRel(-3, 7); MoveRel(3, -7);
  LineRel(3, 7);
  OutTextXY(X0+Wdth-TextWidth(XLbl)+4, Y0+5, XLbl);
  OutTextXY(X0-TextWidth(YLbl)-4, Y0-Hght+2, YLbl);
End;

Function AskUser(Const Msg:String):Word;
Var P:Pointer;
    S:Word;
    MB:PPanel;
    Btn, YB, NB:PButton;
    C:Char;
    L:Word;
    S1, S2:String;
Begin
  S:=ImageSize(210, 198, 430, 282);
  GetMem(P, S);
  GetImage(210, 198, 430, 282, P^);
  MB:=New(PPanel, Init(210, 198, 220, 84, 2));
  YB:=New(PTextButton, Init(250, 243, 50, 20, 2, ''));
  NB:=New(PTextButton, Init(340, 243, 50, 20, 2, ''));
  MB^.Show;
  SetColor(9);
  L:=Pos('\n', Msg);
  If L=0 Then L:=Length(Msg)+1;
  S1:=Copy(Msg, 1, L-1);
  S2:=Copy(Msg, L+2, Length(Msg)-L-1);
  OutTextXY(220+(200-TextWidth(S1)) Shr 1, 215, S1);
  OutTextXY(220+(200-TextWidth(S2)) Shr 1, 225, S2);
  YB^.Show; NB^.Show;
  Btn:=Nil;
  Repeat
    C:=Upcase(ReadKey);
    If C=#0 Then ReadKey;
    If (C='Y')Or(C=#13) Then Btn:=YB;
    If (C='N')Or(C=#27) Then Btn:=NB;
    If Btn<>Nil Then
       Begin
         Btn^.Press(True); Btn^.Show;
         Delay(250);
         Btn^.Press(False);  Btn^.Show;
         Delay(10);
       End;
  Until (C='Y')Or(C='N')Or(C=#13)Or(C=#27);
  Dispose(MB, Done);
  Dispose(YB, Done);
  Dispose(NB, Done);
  PutImage(210, 198, P^, NormalPut);
  FreeMem(P, S);
  If (C='Y')Or(C=#13) Then AskUser:=Yes Else AskUser:=No;
End;

END.