
 unit Ilib_1_1;
 interface
 uses crt,graph;
 const
   AltX=45;
   Esc=27;
   Tab=9;
   back=8;
   upkey=72;
   dounkey=80;
   leftkey=75;
   rightkey=77;
   rightup=73;
   leftup=71;
   leftdoun=79;
   rightdoun=81;
   Enter=13;
   F1=59;
   F2=60;
   F3=61;
   F4=62;
   F5=63;
   F6=64;
   F7=65;
   F8=66;
   F9=67;
   F10=68;
   key0=48;
   key1=49;
   key2=50;
   key3=51;
   key4=52;
   key5=53;
   key6=54;
   key7=55;
   key8=56;
   key9=57;

 type
  IcoRec=array[1..666]of byte;
  PIconRec=^IcoRec;
  Location=record
	    x,y:Word;
	   end;
  TRRect=record
          a,b:Location;
         end;
  TColor=record
          base,light,dark:word;
         end;
  TPpoint=^Tpoint;
  Tpoint=object
           Loc:Location;
           Color,BkColor:Word;
           Visible:boolean;
           constructor init(x1,y1:Integer;colorn:Word)      ;
           destructor  done       ;virtual          ;
           procedure   show       ;Virtual          ;
           procedure   hide       ;Virtual          ;
           procedure   ReDraw                       ;
           procedure   Moving      {(nx,ny:integer)};
           procedure   Move(nx,ny:integer)          ;
           procedure   Moveto(nx,ny:integer)        ;
           procedure   SetNewColor(ncol:Word)       ;
         end;
  TPBaseRect=^TBaseRect;
  TBaseRect=object
         Loc:TRRect;
         Bmp:pointer;
         Color:Word;
         Imsize:word;
         Imag,Visible:boolean;
         constructor Init(R:TRRect;acol:Word;im:boolean);
         destructor  Done;                  virtual;
         procedure   Show;                  virtual;
         procedure   Hide;                  Virtual;
         procedure   ReDraw                        ;
         function    ImageGet:pointer              ;
         function    ImagePut:boolean              ;
         procedure   Get_Dx_Dy(var dx,dy,code:integer)  ;
         procedure   Moving                        ;
         procedure   Move(nx,ny:integer)           ;
         procedure   Moveto(nx,ny:integer)         ;
         procedure   Resizing                     ;
         procedure   Resize(dx,dy:Integer)         ;
         procedure   Resizeto(R:TRRect)          ;
         procedure   SetNewColor(ncol:Word)  ;
         procedure   GetExtent(var R:TRRect);
        end;
  TPRect=^TRect;
  TRect=object(TBaseRect)
         BarSize:byte;
         constructor Init(R:TRRect;acol:Word;im:boolean;Bsize:byte);
         procedure   Show;                  virtual;
         procedure   Hide;                  Virtual;
         procedure   SetNewBar(nBar:Byte)          ;
        end;
  TPBox=^TBox;
  TBox=object(TBaseRect)
         constructor Init(R:TRRect;acol:Word;im:boolean);
         destructor  Done;                  virtual;
         procedure   Show;                  virtual;
         procedure   Hide;                  Virtual;
        end;
  TPIcon=^TIcon;
  TIcon=object(TBaseRect)
         IconPTR:PIconRec;
         constructor Init(L:Location;Ic:PIconRec);
         destructor  Done;                  virtual;
         procedure   Show;                  virtual;
         procedure   Hide;                  Virtual;
         procedure   SetNewColor;
         procedure   SetNewIcon(P:PIconRec)        ;
         procedure   Resizing                 ;
         procedure   Resize(dx,dy:Integer)     ;
         procedure   Resizeto(R:TRRect)         ;
        end;
  TPBasePanel=^TBasePanel;
  TBasePanel=object(TBox)
              Colors:TColor;
              ProGib:boolean;
              Bar:byte;
              constructor Init(R:TRRect;C:Tcolor;im,inout:boolean;Bars:byte);
              procedure   Show;                  virtual;
              procedure SetNewColors(C:TColor);
             end;
  TPBaseKey=^TBaseKey;
  TBaseKey=object(TBasePanel)
              constructor Init(R:TRRect;C:Tcolor;im:boolean;Bars:byte);
              procedure   Show;                  virtual;
              procedure Co_Show;                 Virtual;
              procedure Press_Key;
             end;
  TPFramePanel=^TFramePanel;
  TFramePanel=object(TBasePanel)
              Bare:byte;
              constructor Init(R:TRRect;C:Tcolor;im,inout:boolean;Bars,bares:byte);
              procedure   Show;                  virtual;
             end;
  TPFlyPanel=^TFlyPanel;
  TFlyPanel=object(TBox)
              Colors:TColor;
              constructor Init(R:TRRect;c:TColor);
              destructor  Done;                  virtual;
              procedure   Show;                  virtual;
              procedure   Hide;                  Virtual;
             end;
const
 cDark:TColor=(base:7;light:15;dark:8);
 cGreen:TColor=(base:2;light:10;dark:8);
 cBlue:TColor=(base:1;light:9;dark:8);
 cRed:TColor=(base:4;light:12;dark:8);
var
 cStandartIcon:IcoRec;
 ipx,ipy:integer;
implementation
function TBaseRect.ImageGet:pointer;
var p:pointer;
begin
     if imag=True then
      begin
       getmem(p,ImSize);
       getimage(Loc.a.x,Loc.a.y,Loc.b.x,Loc.b.y,p^);
       {setfillstyle(solidfill,7);
       bar(x,y,x+lenx,y+leny);}
       ImageGet:=p;
      end;
end;
function TBaseRect.ImagePut:boolean;
begin
     ImagePut:=false;
     if imag=True then
      begin
       putimage(Loc.a.x,Loc.a.y,Bmp^,Copyput);
       freemem(Bmp,ImSize);
       Bmp:=nil;
       ImagePut:=true;
      end;
end;
procedure TBaseRect.Get_Dx_Dy;
var
  c:char;
  begin
    c:=readkey;
    code:=ord(c);
    dx:=0;
    dy:=0;
    case code of
     dounkey:begin
                 dy:=1;
                 ipx:=dx;
                 ipy:=dy;
              end;
     upkey:begin
               dy:=-1;
                 ipx:=dx;
                 ipy:=dy;
            end;
     leftkey:begin
                dx:=-1;
                 ipx:=dx;
                 ipy:=dy;
             end;
     leftup:begin
                dx:=-1;
                dy:=-1;
                 ipx:=dx;
                 ipy:=dy;
              end;
     leftdoun:begin
                dx:=-1;
                dy:=1;
                 ipx:=dx;
                 ipy:=dy;
              end;
     rightkey:begin
                 dx:=1;
                 ipx:=dx;
                 ipy:=dy;
               end;
     rightup:begin
                 dx:=1;
                 dy:=-1;
                 ipx:=dx;
                 ipy:=dy;
               end;
     rightdoun:begin
                 dx:=1;
                 dy:=1;
                 ipx:=dx;
                 ipy:=dy;
               end;
     Tab:begin
         dx:=ipx*8;
         dy:=ipy*8;
         end;
     end;
end;

constructor Tpoint.init;
begin
 Loc.x:=x1;
 Loc.y:=y1;
 color:=colorn;
 visible:=false;
end;
destructor Tpoint.done;
begin
 hide;
end;
procedure Tpoint.show;
begin
BkColor:=GetPixel(Loc.x,Loc.y);
if visible=false then
 begin
  PutPixel(Loc.x,Loc.y,Color);
  visible:=True;
 end;
end;
procedure Tpoint.hide;
begin
if visible=true then
 begin
  putpixel(Loc.x,Loc.y,BkColor);
  visible:=False;
 end;
end;
procedure   Tpoint.ReDraw;
begin
 Hide;
 Show;
end;
procedure   Tpoint.Moving       {(nx,ny:integer)};
  var
  nx,ny,code:integer;
  c:char;
  begin
    repeat
    c:=readkey;
    code:=ord(c);
    nx:=0;
    ny:=0;
    case code of
     dounkey:begin
                 ny:=1;
              end;
     upkey:begin
               ny:=-1;
            end;
     leftkey:begin
                nx:=-1;
             end;
     leftup:begin
                nx:=-1;
                ny:=-1;
              end;
     leftdoun:begin
                nx:=-1;
                ny:=1;
              end;
     rightkey:begin
                 nx:=1;
               end;
     rightup:begin
                 nx:=1;
                 ny:=-1;
               end;
     rightdoun:begin
                 nx:=1;
                 ny:=1;
               end;
     end;
      hide;
      Loc.x:=Loc.x+nx;
      Loc.y:=Loc.y+ny;
      show;
  until code=Esc;
  end;
procedure   Tpoint.Move;
begin
 hide;
 Loc.x:=Loc.x+nx;
 Loc.y:=Loc.y+ny;
 show;
end;
procedure   Tpoint.Moveto;
begin
 hide;
 Loc.x:=nx;
 Loc.y:=ny;
 show;
end;
procedure Tpoint.SetNewColor;
begin
Color:=ncol;
end;
constructor TBaseRect.init;
  begin
   Loc:=R;
   Color:=acol;
   imag:=im;
   Visible:=False;
   Bmp:=nil;
   ImSize:=Imagesize(Loc.a.x,Loc.a.y,Loc.b.x,Loc.b.y);
  end;

destructor  TBaseRect.done;
  begin
   hide;
  end;

procedure   TBaseRect.show;
 var col:byte;
  begin
   if Visible=False then
    begin
     Visible:=True;
     Bmp:=ImageGet;
     col:=getcolor;
     setcolor(Color);
     rectangle(Loc.a.x,Loc.a.y,Loc.b.x,Loc.b.y);
     setcolor(col);
    end;
  end;

procedure   TBaseRect.hide;
 var col:byte;
  begin
   if Visible=True then
    begin
     Visible:=False;
     if not(ImagePut) then
       begin
        col:=getcolor;
        setcolor(GetbkColor);
        rectangle(Loc.a.x,Loc.a.y,Loc.b.x,Loc.b.y);
        setcolor(col);
       end;
   end;
  end;
Procedure   TBaseRect.ReDraw;
var a:boolean;
    p:pointer;
begin
a:=Imag;
Imag:=False;
Visible:=False;
p:=bmp;
Show;
Imag:=a;
bmp:=p;
end;
procedure   TBaseRect.Move;
begin
 if (Loc.a.x+nx<0)or(Loc.b.x+nx>getmaxx)or(Loc.a.y+ny<0)or(Loc.b.y+ny>getmaxy)then exit;
 hide;
 inc(Loc.a.x,nx);
 inc(Loc.a.y,ny);
 inc(Loc.b.x,nx);
 inc(Loc.b.y,ny);
 show;
end;
procedure   TBaseRect.Resize;
begin
 if (Loc.b.x+dx>getmaxx)or(Loc.b.y+dy>getmaxy)or
 (Loc.b.x+dx<0)or(Loc.b.y+dy<0)then exit;
 hide;
 inc(Loc.b.x,dx);
 inc(Loc.b.y,dy);
 ImSize:=Imagesize(Loc.a.x,Loc.a.y,Loc.b.x,Loc.b.y);
 show;
end;
procedure   TBaseRect.Moveto;
begin
 if (nx<0) or (Nx>getmaxx) or (ny<0) or (ny>getmaxy) then exit;
 hide;
 loc.b.x:=nx+loc.b.x-loc.a.x;
 loc.b.y:=ny+loc.b.y-loc.a.y;
 loc.a.x:=nx;
 loc.a.y:=ny;
 show;
end;
procedure   TBaseRect.Resizeto;
begin
 hide;
 Loc:=R;
 ImSize:=Imagesize(Loc.a.x,Loc.a.y,Loc.b.x,Loc.b.y);
 show;
end;
procedure   TBaseRect.Moving           {(nx,ny:integer)};
  var
  nx,ny,code:integer;
  c:char;
  begin
    repeat
      get_dx_dy(nx,ny,code);
      if (nx=0)and(ny=0)then Continue;
      if code=13 then break;
      hide;
      if (Loc.b.x+nx>getmaxx)or(Loc.b.y+ny>getmaxy)or
      (Loc.a.y+ny<0)or(Loc.a.x+nx<0)then Continue;
      inc(Loc.a.x,nx);
      inc(Loc.a.y,ny);
      inc(Loc.b.x,nx);
      inc(Loc.b.y,ny);
      show;
  until code=Enter;
  end;

procedure   TBaseRect.Resizing;
  var
  nx,ny,code:integer;
  c:char;
  begin
      repeat
      get_dx_dy(nx,ny,code);
      if (nx=0)and(ny=0)then Continue;
      if code=13 then break;
      hide;
      if (Loc.b.x+nx>getmaxx)or(Loc.b.y+ny>getmaxy)or
      (Loc.b.x+nx<0)or(Loc.b.y+ny<0)then Continue;
      inc(Loc.b.x,nx);
      inc(Loc.b.y,ny);
      ImSize:=Imagesize(Loc.a.x,Loc.a.y,Loc.b.x,Loc.b.y);
      show;
    until code=enter;
  end;
procedure TBaseRect.SetNewColor;
begin
Color:=ncol;
ReDraw;
end;
procedure TBaseRect.GetExtent;
begin
R:=Loc;
end;
constructor TBox.init;
  begin
   inherited init(R,acol,im);
  end;

destructor  TBox.done;
  begin
   hide;
  end;

procedure   TBox.show;
 var col:byte;
  begin
   if Visible=False then
    begin
     Visible:=True;
     Bmp:=ImageGet;
     col:=getcolor;
     setcolor(Color);
     setfillstyle(solidfill,Color);
     bar(Loc.a.x,Loc.a.y,Loc.b.x,Loc.b.y);
     setcolor(col);
    end;
  end;

procedure   TBox.hide;
 var col:byte;
  begin
   if Visible=True then
     if not(ImagePut) then
       begin
        col:=getcolor;
        setcolor(GetbkColor);
        setfillstyle(Emptyfill,Color);
        bar(Loc.a.x,Loc.a.y,Loc.b.x,Loc.b.y);
        setcolor(col);
       end;
   Visible:=False;
 end;
constructor TFlyPanel.init;
  begin
   colors:=c;
   inherited init(R,c.base,true);
  end;

destructor  TFlyPanel.done;
  begin
   hide;
  end;

procedure   TFlyPanel.show;
 var col:byte;
  begin
   if Visible=False then
    begin
     Visible:=True;
     Bmp:=ImageGet;
     col:=getcolor;
     setcolor(Color);
     setfillstyle(solidfill,Color);
     bar(Loc.a.x,Loc.a.y,Loc.b.x-2,Loc.b.y-2);
     setcolor(colors.dark);
     rectangle(Loc.a.x,Loc.a.y,Loc.b.x-2,Loc.b.y-2);
     line(loc.a.x+2,loc.b.y-1,loc.b.x,loc.b.y-1);
     line(loc.a.x+2,loc.b.y,loc.b.x,loc.b.y);
     line(loc.b.x-1,loc.a.y+2,loc.b.x-1,loc.b.y);
     line(loc.b.x,loc.a.y+2,loc.b.x,loc.b.y);
     setcolor(col);
    end;
  end;

procedure   TFlyPanel.hide;
 var col:byte;
  begin
   if Visible=True then
    begin
     Visible:=False;
     if not(ImagePut) then
       begin
        col:=getcolor;
        setcolor(GetbkColor);
        setfillstyle(Emptyfill,Color);
        bar(Loc.a.x,Loc.a.y,Loc.b.x,Loc.b.y);
        setcolor(col);
       end;
   end;
  end;
constructor TRect.Init;
begin
 Inherited Init(R,acol,im);
 BarSize:=Bsize;
end;
procedure   TRect.show;
var col,cb:byte;
 begin
  inherited Show;
  if Barsize>1 then
   begin
    col:=getcolor;
    setcolor(Color);
    for cb:=2 to Barsize do rectangle(Loc.a.x+cb-1,Loc.a.y+cb-1,Loc.b.x-cb+1,Loc.b.y-cb+1);
    setcolor(col);
   end;
 end;
procedure   TRect.hide;
 var col,cb:byte;
  begin
   if Visible=True then
    begin
     Visible:=False;
     if not(ImagePut) then
       begin
       if Barsize>=1 then
        begin
        col:=getcolor;
        setcolor(getbkcolor);
        for cb:=1 to Barsize do rectangle(Loc.a.x+cb-1,Loc.a.y+cb-1,Loc.b.x-cb+1,Loc.b.y-cb+1);
        setcolor(col);
        end;
      end;
   end;
  end;

procedure   TRect.SetNewBar(nBar:Byte);
begin
 hide;
 BarSize:=NBar;
 show;
end;
constructor TIcon.init;
  var R:TRRect;
      P:PIconRec;
  begin
   R.a:=L;
   R.b:=L;
   inc(R.b.x,32);
   inc(R.b.y,32);
   inherited init(R,0,True);
   if Ic<>nil
    then IconPTR:=Ic
    else
    begin
     new(P);
     P^:=cStandartIcon;
     IconPTR:=P;
    end;
  end;

destructor  TIcon.done;
  begin
   hide;
   dispose(IconPTR);
  end;

procedure   TIcon.show;
 var col:byte;
  begin
   if Visible=False then
    begin
     Visible:=True;
     getmem(Bmp,ImSize);
     getimage(Loc.a.x,Loc.a.y,Loc.b.x,Loc.b.y,Bmp^);
     PutImage(Loc.a.x,Loc.a.y,IconPtr^,Copyput);
    end;
  end;

procedure   TIcon.hide;
 var col:byte;
  begin
   if Visible=True then
    begin
     Visible:=False;
     putimage(Loc.a.x,Loc.a.y,Bmp^,Copyput);
     freemem(Bmp,ImSize);
     Bmp:=nil;
    end;
  end;
procedure TIcon.Resizing;
begin
end;
procedure TIcon.Resize;
begin
end;
procedure TIcon.Resizeto;
begin
end;
procedure   TIcon.SetNewColor;
begin
end;
procedure   TIcon.SetNewIcon;
begin
dispose(IconPTR);
IconPTR:=P;
if p=nil then
begin
 new(P);
 P^:=cStandartIcon;
 IconPTR:=P;
 p:=nil;
end;
ReDraw;
end;

constructor TBasePanel.init;
begin
inherited init(R,C.base,im);
Colors:=C;
ProGib:=inout;
Bar:=bars;
end;
procedure TBasePanel.show;
var cb,col:word;
    imm:boolean;
    P:pointer;
begin
   if Visible=False then
    begin
p:=ImageGet;
imm:=Imag;
Imag:=False;
inc(Loc.a.x,bar);
inc(Loc.a.y,bar);
dec(Loc.b.x,bar);
dec(Loc.b.y,bar);
inherited show;
inc(Loc.b.x,bar);
inc(Loc.b.y,bar);
dec(Loc.a.x,bar);
dec(Loc.a.y,bar);
Imag:=imm;
BMP:=p;
Visible:=True;
col:=getcolor;
case ProGib of
true:begin
       setcolor(Colors.light);
       for cb:=0 to bar-1 do begin
       line(Loc.a.x+cb,Loc.a.y+cb,Loc.b.x-cb-1,Loc.a.y+cb);
       line(Loc.a.x+cb,Loc.a.y+cb,Loc.a.x+cb,Loc.b.y-cb); end;
       setcolor(Colors.Dark);
       for cb:=0 to bar-1 do begin
       line(Loc.b.x-cb,Loc.b.y-cb,Loc.a.x+1+cb,Loc.b.y-cb);
       line(Loc.b.x-cb,Loc.b.y-cb,Loc.b.x-cb,Loc.a.y+cb);end;
      end;
false:begin
       setcolor(Colors.Dark);
       for cb:=0 to bar-1 do begin
       line(Loc.a.x+cb,Loc.a.y+cb,Loc.b.x-cb-1,Loc.a.y+cb);
       line(Loc.a.x+cb,Loc.a.y+cb,Loc.a.x+cb,Loc.b.y-cb); end;
       setcolor(Colors.Light);
       for cb:=0 to bar-1 do begin
       line(Loc.b.x-cb,Loc.b.y-cb,Loc.a.x+1+cb,Loc.b.y-cb);
       line(Loc.b.x-cb,Loc.b.y-cb,Loc.b.x-cb,Loc.a.y+cb);end;
      end;
end;
setcolor(col);
end;
end;
procedure TBasePanel.SetNewColors;
begin
if visible then begin
                 hide;
                 Colors:=c; color:=c.base;
                 show;
                end
else BEGIN Colors:=c; color:=c.base; end;
end;
constructor TBaseKey.init;
begin
inherited init(R,C,im,True,bars);
end;
procedure TBaseKey.show;
begin
   if Visible=False then if ProGib then inherited show else co_show;
end;
procedure TBaseKey.co_show;
 var col:byte;
begin
   if Visible=False then
    begin
     Visible:=true;
     Bmp:=ImageGet;
     col:=getcolor;
     setcolor(Colors.dark);
     setfillstyle(solidfill,colors.base);
     Graph.bar(Loc.a.x,Loc.a.y,Loc.b.x,Loc.b.y);
     Graph.rectangle(Loc.a.x,Loc.a.y,Loc.b.x,Loc.b.y);
     setcolor(col);
    end;
end;
procedure TBaseKey.Press_Key;
begin
ProGib:=not ProGib;
ReDraw;
delay(150);
ProGib:=not ProGib;
ReDraw;
end;
{TKey}
constructor TFramePanel.init;
begin
inherited init(R,C,im,inout,bars);
Bare:=bares;
end;
procedure TFramePanel.show;
var cb,col:word;
    imm:boolean;
    P:pointer;
begin
   if Visible=False then
    begin
inherited show;
col:=getcolor;
case not(ProGib) of
true:begin
       setcolor(Colors.light);
       for cb:=0 to bar-1 do begin
       line(Loc.a.x+cb+bar+bare,Loc.a.y+cb+bar+bare,Loc.b.x-cb-1-bar-bare,Loc.a.y+cb+bar+bare);
       line(Loc.a.x+cb+bar+bare,Loc.a.y+cb+bar+bare,Loc.a.x+cb+bar+bare,Loc.b.y-cb-bar-bare); end;
       setcolor(Colors.Dark);
       for cb:=0 to bar-1 do begin
       line(Loc.b.x-cb-bar-bare,Loc.b.y-cb-bar-bare,Loc.a.x+1+cb+bar+bare,Loc.b.y-cb-bar-bare);
       line(Loc.b.x-cb-bar-bare,Loc.b.y-cb-bar-bare,Loc.b.x-cb-bar-bare,Loc.a.y+cb+bar+bare);end;
      end;
false:begin
       setcolor(Colors.Dark);
       for cb:=0 to bar-1 do begin
       line(Loc.a.x+cb+bar+bare,Loc.a.y+cb+bar+bare,Loc.b.x-cb-1-bar-bare,Loc.a.y+cb+bar+bare);
       line(Loc.a.x+cb+bar+bare,Loc.a.y+cb+bar+bare,Loc.a.x+cb+bar+bare,Loc.b.y-cb-bar-bare); end;
       setcolor(Colors.Light);
       for cb:=0 to bar-1 do begin
       line(Loc.b.x-cb-bar-bare,Loc.b.y-cb-bar-bare,Loc.a.x+1+cb+bar+bare,Loc.b.y-cb-bar-bare);
       line(Loc.b.x-cb-bar-bare,Loc.b.y-cb-bar-bare,Loc.b.x-cb-bar-bare,Loc.a.y+cb+bar+bare);end;
      end;
end;
{***********}
setcolor(col);
end;
end;

var cb:word;
begin
writeln ('Graphics_Interface_Ver1.5_Init_Ok.');
for cb:=1 to 666 do cStandartIcon[cb]:=(cb mod 255);
cStandartIcon[1]:=32;
cStandartIcon[2]:=0;
cStandartIcon[3]:=32;
cStandartIcon[4]:=0;
cStandartIcon[5]:=24;
cStandartIcon[6]:=254;
ipx:=0;ipy:=0;
end.
