Uses CRT, Graph, TVPart, Views;

Var Plain, Shter:Pointer;

Procedure EGAVGADriver; External;
{$L EGAVGA.OBJ}

Procedure _PutImage(X, Y:Integer; Var P; PP:Byte);
Begin
  PutImage(X+320, 480-Y, P, PP);
End;

Procedure DrawBomb(X, Y:Integer);
Begin
  SetColor(15);
  Circle(320+X, 480-Y, 3);
  SetFillStyle(1, 7); FloodFill(320+X, 480-Y, 15);
End;

Procedure _Bar(X1, Y1, X2, Y2:Word);
Begin
  Bar(320+X1, 480-Y1, 320+X2, 480-Y2);
End;

Procedure DrawExplosive(GunX, GunY:Word);
Const
     CntCols    = 4;
     Cirs:Array[1..CntCols, 1..2]Of Byte=((15,15),(25,14),(32,12),(40,6));
Var I,C:Byte;
Begin
  I:=1; C:=1;
  While I<=CntCols Do
        Begin
          SetColor(Cirs[I, 2]);
          While C<=Cirs[I, 1] Do
                Begin
                  Circle(320+GunX, 480-GunY, C);
                  Inc(C);
                End;
          Inc(I);
        End;
End;

Procedure GameCycle;
Const ImageLen=110;
      ImageHgh=45;

Const GD:Integer=VGA;
      GM:Integer=VGAHi;
Var PlainX:Integer;
    C:Char;
    GunX, GunY:Integer;
    DY:Real;
    DX:Real;
    rGunX, rGunY:Real;
    Alph, TrCOS, TrSIN:Real;
    E:Integer;
Begin
  PlainX:=-260;
  GunX:=-20000; GunY:=-20000;
  InitGraph(GD, GM, '');
  E:=GraphResult;
  If E<>0 Then
     Begin
       WriteLn('Graphic''s initialization error : ', GraphErrorMsg(E));
       ReadKey;
       Exit;
     End;
  C:=#0;
  SetFillStyle(1, 2); Bar(0, 480-GrndHght, 640, 480);
  SetFillStyle(1, 1); Bar(0, 0, 640, 480-GrndHght);
  Repeat
    If KeyPressed Then C:=ReadKey;
    If C=#13 Then
       Begin
         GunX:=GunPos; GunY:=GrndHght+10;
         rGunX:=GunX; rGunY:=GunY;
         DX:=PlainX-GunX; DY:=(PlainHght-GunY);
         Alph:=2*ArcTan(-(2*DX-SQRT(4*DX*DX+3*DY*DY))/(3*DY));
         TrCOS:=COS(Alph);
         TrSIN:=SIN(Alph);
         C:=#0;
       End;
    If GunX<>-20000 Then DrawBomb(GunX, GunY);
    _PutImage(PlainX-ImageLen Shr 1, PlainHght+ImageHgh, Plain^, NormalPut);
    _PutImage(GunPos-20, GrndHght+10, Shter^, NormalPut);
    Delay(20); SetColor(1);
    Line(PlainX+320-ImageLen Shr 1, 480-(PlainHght+ImageHgh),
         PlainX+320-ImageLen Shr 1, 480-(PlainHght+ImageHgh)+2);
    PlainX:=PlainX+1;
    If GunX<>-20000 Then
       Begin
         SetFillStyle(1, 1);
         _Bar(GunX-5, GunY+5, GunX+5, GunY-5);
         rGunX:=rGunX+2*TrCOS; GunX:=Round(rGunX);
         rGunY:=rGunY+2*TrSIN; GunY:=Round(rGunY);
       End;
    If GunY+5>=PlainHght Then
       Begin
         SetFillStyle(1, 1);
         _Bar(PlainX-ImageLen Shr 1, PlainHght+ImageHgh,
              PlainX+ImageLen Shr 1, PlainHght{+ImageHgh});
         DrawExplosive(GunX, GunY);
         ReadKey;
         SetFillStyle(1, 2); Bar(0, 480-GrndHght, 640, 480);
         SetFillStyle(1, 1); Bar(0, 0, 640, 480-GrndHght);
         PlainX:=-260;
         GunX:=-20000; GunY:=-20000;
       End;
    If (PlainX+ImageLen Shr 1)=315 Then
       Begin
         SetFillStyle(1, 2); Bar(0, 480-GrndHght, 640, 480);
         SetFillStyle(1, 1); Bar(0, 0, 640, 480-GrndHght);
         PlainX:=-260;
         GunX:=-20000; GunY:=-20000;
       End;
  Until C=#27;
  CloseGraph;
End;

Var F:File;
    PSz, SSz:Word;
    App:TShootApp;

BEGIN
  If RegisterBGIDriver(@EGAVGADriver)=0 Then Halt;
  Assign(F, 'plain.dat'); Reset(F, 1);
  BlockRead(F, PSz, SizeOf(PSz));
  BlockRead(F, SSz, SizeOf(SSz));
  GetMem(Plain, PSz); GetMem(Shter, SSz);
  BlockRead(F, Plain^, PSz);
  BlockRead(F, Shter^, SSz);
  Close(F);
  Repeat
    App.Init;
    App.Run;
    App.Done;
    If Status=cmCancel Then
       Begin
         FreeMem(Plain, PSz);
         FreeMem(Shter, SSz);
         Halt;
       End;
    WriteLn('   ENTER - ५, ESC - 室  ');
    WriteLn('        த ५');
    WriteLn('    ⨦ ࠢ  ࠭ ᠬ ६頥   ');
    WriteLn(' ᨬ  ⢨  ⢨ ᭠鸞  ࠭.');
    WriteLn('      砫 .');
    ReadKey;
    GameCycle;
  Until False;
END.