{$x+}
unit Tprelib;
Interface
uses crt,graph,Ilib_1_1;
type
     TextPal=record
              Color,ColorBk:word;
             end;
     TPTextLine=^TTextLine;
     TTextLine=object
             {Shadow:boolean;}
             Loc:TRRect;
             constructor init(R:TRRect;C:TextPal;S:string{;Shad:boolean});
             destructor done;                   virtual;
             procedure   Show;                  virtual;
             procedure   Hide;                  Virtual;
             procedure   ReDraw                        ;
             procedure   Resizeto(R:TRRect);
             procedure   SetNewColor(col:TextPal);
             procedure   GetExtent(var R:TRRect);
            private
             str:string;
             TPal:TextPal;

            end;
     TPBlocedLine=^TBlocedLine;
     TBlocedLine=object(TTextLine)
             constructor init(R:TRRect;C:TextPal;Opt:Byte;S:string{;Shad:boolean});
             procedure   Show;                  virtual;
             procedure   Hide;                  Virtual;
             procedure   Formating(var xc,yc:word;var st:string);
             procedure   ChangeOpt(var O:byte);
            private
             Options:Byte;
            end;
const
 Ctp_b_g:TextPaL=(color:1;colorbk:7);
  co_Centr=1;
  co_Default=2;
  co_Left=4;
  co_Right=8;
  co_Centry=16;
  co_Down=32;
  co_Up=64;

Var cTextDefaultMode:byte;

Implementation
constructor TTextLine.init(R:TRRect;C:TextPal;S:string{;Shad:boolean});
begin
Loc:=R;
TPal:=C;
Str:=S;
end;
destructor TTextLine.done;
begin
hide;
end;
procedure  TTextLine.Show;
var cl:word;
begin
cl:=getcolor;
setcolor(TPal.Color);
outtextxy(Loc.a.x,Loc.a.y,Str);
setcolor(cl);
end;
procedure  TTextLine.Hide;
var cl:word;
begin
cl:=getcolor;
setcolor(TPal.colorbk);
outtextxy(Loc.a.x,Loc.a.y,Str);
setcolor(cl);
end;
procedure  TTextLine.ReDraw;
begin
show;
end;
procedure TTextLine.Resizeto;
begin
hide;
Loc:=r;
show;
end;
procedure TTextLine.SetNewColor;
begin
TPal:=col;
end;
procedure TTextLine.GetExtent;
begin
R:=Loc;
end;

constructor TBlocedLine.init;
begin
inherited init(R,C,S);
Options:=Opt;
end;
procedure  TBlocedLine.Formating(var xc,yc:word;var st:string);
var size:byte;
    flg:boolean;
begin
flg:=false;
size:=(Loc.b.x-Loc.a.x) div 8;
if Options=co_default then
 begin
  flg:=True;
  Options:=cTextDefaultMode;
 end;
(*
case Options of
{co_Default }
{ co_Centr: }
   co_Left:begin
         St:=str;
         st[0]:=char(size);
        end;
   co_Right:begin
         St:=str;
         delete(st,1,byte(str[0])-size);
        end;
 end;*)
if  (options and co_Centry) <> 0 then yc:=loc.a.y+((loc.b.y-loc.a.y) div 2)-3;
if  (options and co_Down) <> 0 then yc:=loc.b.y-9;
if  (options and co_Up) <> 0 then yc:=loc.a.y;
if  (options and co_Centr) <> 0 then
 begin
  if byte(str[0])>size then
                        begin
                         xc:=loc.a.x;
                         st:=str;
                         delete(st,byte(str[0])-((byte(str[0])-size) div 2)+1,((byte(str[0])-size) div 2));
                         delete(st,1,((byte(str[0])-size) div 2));
                        end
                       else
                        begin
                         st:=str;
                         xc:=loc.a.x+1+(Loc.b.x-Loc.a.x-(byte(str[0]))shl 3)shr 1;
                        end;
 end;
if  (options and co_Left) <> 0 then
 begin
  xc:=loc.a.x;
  st:=str;
  if byte(str[0])>size then st[0]:=char(size);
 end;
if  (options and co_Right) <> 0 then
 begin
  st:=str;
  if byte(str[0])>size then
   begin
    delete(st,1,byte(str[0])-size);
    xc:=loc.a.x;
   end
  else
   begin
    xc:=loc.a.x+(size-byte(str[0]))shl 3;
   end;
 end;
if flg then options:=co_Default;
end;
procedure  TBlocedLine.Show;
var cl,x,y:word;
    st:string;
begin
cl:=getcolor;
setcolor(TPal.Color);
formating(x,y,st);
outtextxy(x,y,St);
setcolor(cl);
end;

procedure  TBlocedLine.Hide;
var cl,x,y:word;
    St:string;
begin
cl:=getcolor;
setcolor(TPal.colorbk);
Formating(x,y,st);
outtextxy(x,y,St);
setcolor(cl);
end;
procedure TBlocedLine.ChangeOpt;
var b:byte;
begin
b:=Options;
hide;
Options:=O;
show;
O:=b;
end;

begin
writeln('Text_Base_Supporting_Init_Ok.');
cTextDefaultMode:=co_centry+co_centr;
end.